### https://docs.broadcom.com/docs-and-downloads/docs/linux_sta/hybrid-v35_64-nodebug-pcoem-6_30_223_271.tar.gz
%define debug_package %{nil}
%define oname	hybrid-v35
%define dwver	6_30_223_271
%define kname	wl


Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.271
Release:	%mkrel 32
Source0:	https://docs.broadcom.com/docs-and-downloads/docs/linux_sta/hybrid-v35_64-nodebug-pcoem-6_30_223_271.tar.gz
Source1:	broadcom-wl-blacklist.conf
Source2:	broadcom-wl-alias.conf
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware
URL:		http://www.broadcom.com/support/802.11/linux_sta.php
Requires: gcc

# need patchmatch to prevent for early-kernels
# if need add this: PATCH[0]="broadcom-wl-fix-k5.18.patch"
# if need add this: PATCH_MATCH[0]="5\.1[7-8]\.[0-9]"
#Source3:	broadcom-wl-fix-k5.18.patch  instead of patch32

Patch0:		license.patch
Patch6:		broadcom-wl-6.30.223.271-fix-null-pointer-crash.patch
Patch7:		broadcom-wl-6.30.223.271-kernel-4.3-rdtscl-buildfix.patch
Patch8:		broadcom-wl-6.30.223.271-kernel-4.7-buildfix.patch
Patch9:		broadcom-wl-6.30.223.271-kernel-4.8-buildfix.patch
Patch10:	broadcom-wl-6.30.223.271-kernel-4.11-buildfix.patch
Patch11:	broadcom-wl-6.30.223.271-kernel-4.12-buildfix.patch
# reedit to aur patches for kernel-6.0 keep it working on older kernel?
# nogo aur here Patch11:	broadcom-wl-6.30.223.271-kernel-4.12-buildfix-6.0.patch
Patch12:	broadcom-wl-6.30.223.271-kernel-4.14-buildfix.patch
# as33 reedit to aur patches for kernel-6.0 keep it working on older kernel?
# nogo aur here Patch33:	broadcom-wl-6.30.223.271-kernel-4.14-buildfix-6.0.patch
Patch13:	broadcom-wl-6.30.223.271-kernel-4.15-buildfix.patch
Patch14:	broadcom-wl-6.30.223.271-kernel-5.1-buildfix.patch
Patch15:	broadcom-wl-6.30.223.271-debian-fix-kernel-warnings.patch
Patch16:	broadcom-wl-6.30.223.271-fix_mac_profile_discrepancy.patch
Patch17:	broadcom-wl-6.30.223.271-allow-user_ioctl.patch
Patch18:	broadcom-wl-6.30.223.271-ifname-wlan.patch
Patch19:	broadcom-wl-6.30.223.271-kernel-5.6-buildfix.patch
Patch20:	broadcom-wl-6.30.223.271-no-date-time.patch
Patch21:	broadcom-wl-6.30.223.271-debian-fix-dkms-build-error.patch
Patch22:	broadcom-wl-6.30.223.271-kernel-5.9-buildfix.patch
Patch30:	broadcom-wl-new-makefile.patch
Patch31:	broadcom-wl-6.30.223.271-kernel-5.17-buildfix.patch
Patch32:	broadcom-wl-6.30.223.271-kernel-5.18.patch
# nogo-aur here Patch34:	broadcom-wl-6.30.223.271-kernel-6.0.1-buildfix-6.0.patch
Patch34:    broadcom-wl-6.30.223.271-kernel-6.0.0.patch
# new for 6.1..
Patch35:	broadcom-wl-6.30.223.271-kernel-6.1-buildfix.patch

%description
For older kernel-versions < 4.11 please use the release 4 of this package!
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters linux-4.11.
Group:		System/Kernel and hardware
Provides:	kmod(%{kname}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms
Requires:	%{name}-blacklist


%description -n dkms-%{name}
For older kernel-versions < 4.11 please use the release 4 of this package!
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.
Broadcom BCM4311 (PCI IDs 14e4:4311, 14e4:4312)
Broadcom BCM4312 (PCI ID 14e4:4315)
Broadcom BCM4313 (PCI ID 14e4:4727)
Broadcom BCM4321 (PCI IDs 14e4:4328, 14e4:4329, 14e4:432a)
Broadcom BCM4322 (PCI IDs 14e4:432b, 14e4:432c, 14e4:432d)
Broadcom BCM43224 (PCI IDs 14e4:0576, 14e4:4353)
Broadcom BCM43225 (PCI ID 14e4:4357)
Broadcom BCM43227 (PCI ID 14e4:4358)
Broadcom BCM43228 (PCI ID 14e4:4359)
Broadcom BCM43142 (PCI ID 14e4:4365)
Broadcom BCM4331 (PCI ID 14e4:4331)
Broadcom BCM4352 (PCI ID 14e4:43b1)
Broadcom BCM4360 (PCI IDs 14e4:43a0, 14e4:4360) 

%package -n %{name}-blacklist
Summary:	Kernel driver blacklist for Broadcom wireless adapters
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware

%description -n %{name}-blacklist
This package will blacklist the following drivers to allow the
Broadcom WL driver to work with recent kernels.
b43
b43legacy
b44
bcma
brcm80211
brcmfmac
brcmsmac
ssb
	the tg3 is not blacklisted  

%prep
### we only have arch x86_64
### -T -c -a1 %{oname}

%setup -q -T -c -a0 %{oname} 
%apply_patches
find -type f -exec chmod 0644 {} \;
sed -e "/BRCM_WLAN_IFNAME/s:eth:wlan:" -i src/wl/sys/wl_linux.c

sed -i 's/get_ds()/KERNEL_DS/g' src/wl/sys/wl_iw.c
sed -i 's/get_ds()/KERNEL_DS/g' src/wl/sys/wl_cfg80211_hybrid.c
# fix: override GCC detection to assume >= 4.9 to fix GCC 10
sed -i '/GE_49 :=/s|:= .*|:= 1|' Makefile
#rel20 not provide this as by versionstring see patch14

%build

%install
rm -rf %{buildroot}

# install broadcom-conf's
install -m755 -d %{buildroot}%{_sysconfdir}/modprobe.d/
install -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/modprobe.d/
install -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/modprobe.d/

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/patches
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
###cp %{S:3} %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/patches/

cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
PACKAGE_NAME[0]=%{name}
PACKAGE_VERSION[0]=%{version}-%{release}
DEST_MODULE_LOCATION[0]=/kernel/3rdparty/%{name}
BUILT_MODULE_NAME[0]=%{kname}
MAKE[0]="export IGNORE_CC_MISMATCH=1; 'make' clean KSRC=\${kernel_source_dir} SKIP_STACK_VALIDATION=1 all"
AUTOINSTALL=yes
EOF


%post -n dkms-%{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod b44 >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/rmmod %{kname} >/dev/null 2>&1 ||:
	/sbin/depmod -a 2>&1 ||:
echo "all wl broadcom modules unloaded"
fi

%preun -n dkms-%{name}
# rmmod can fail
/sbin/rmmod %{kname} >/dev/null 2>&1 ||:
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || :


%posttrans -n %{name}-blacklist
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod b44 >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/modprobe wl >/dev/null 2>&1 ||:
fi

%clean
rm -rf %{buildroot}


%files -n dkms-%{name}
%doc lib/LICENSE.txt
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*

%files -n %{name}-blacklist
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/modprobe.d/broadcom-wl-alias.conf
%config(noreplace) %{_sysconfdir}/modprobe.d/broadcom-wl-blacklist.conf


%changelog
* Tue Dec 27 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-32pclos2022
- fix makefile-patch,
- add patch35-fixbuild on kernel-6.1 series

* Sun Nov 13 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-31pclos2022
- ad a hint in -blacklist-description for excluding tg3

* Sat Nov 12 2022 tex - 6.30.223.271-30pclos2022
- exclude tg3

* Fri Oct 14 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-29pclos2022
- switch to mga9 patch for kernel-6.0.0  installation works, module build
- - below breaks module build
- first test rebuild, edit patches sync to AUR, Tex suggested it

* Tue Jun 14 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-28pclos2022
- rebuild

* Tue Jun 07 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-27pclos2022
- rebuild 
- edit patchmatch to PATCH_MATCH[0]="5\.1[7-8]\.[0-9]"

* Sat Apr 02 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-26pclos2022
- rebuild -- add patch23 fix for kernel-5.18.-- this patch commes without
- supporting prevent faulty-match in early kernels
- so it's need to apply with patchmatch only on targeted kernel-versions
- patch31 fix build only in kernel-5.17...

* Tue Feb 08 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-25pclos2022
- rebuid
- patch30

* Tue Feb 08 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-24pclos2022
- rebuid
- KBASE=\${kernel_source_dir},  := -> ?= in MAKE

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 6.30.223.271-23pclos2022
- updates 
- add export IGNORE_CC_MISMATCH=1;

* Tue Feb 09 2021 tex - 6.30.223.271-22pclos2021
- build for kernel 5.10

* Mon Jul 27 2020 onkelho <oh.quait at gmail.com> - 6.30.223.271-18pclos2020
- rebuild fix gcc10 build

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 6.30.223.271-17pclos2020
- rebuild fix kernel-5.6...
- thanks to aur for the patch

* Tue Aug 13 2019 tex - 6.30.223.271-16pclos2019
- rebuild against updates

* Mon May 13 2019 onkelho <oh.quait at gmail.com> 6.30.223-271-15pclos2019
- to test before prepare patches, added sed's from aur before %build
- back to broadcom-wl-blacklist package - pclos-confirm

* Sun May 12 2019 onkelho <oh.quait at gmail.com> - 6.30.223-271-13pclos2019
- rebuild fixed linux-5.1.1
- add patch 010 

* Mon Jan 21 2019 onkelho <oh.quait@gmail.com> 6.30.223-271-12pclos2019
- rebuild, add supported devices in description

* Sat Jan 19 2019 onkelho <oh.quait@gmail.com> 6.30.223-271-11pclos2019
- rebuild, freshing broadcom-wl-blacklist.conf with debians last

* Sat Jan 05 2019 onkelho <oh.quait@gmail.com> 6.30.223-271-10pclos2019
- rebuild, obsoletes broadcom-wl-blacklist package, ship's from here
- as -common

* Sun Jun 17 2018 bb2 <bb2> - 6.30.223-271-9pclos2018
- SKIP_STACK_VALIDATION=1

* Mon Feb 12 2018 onkelho <oh.quait at gmail.com> 6.30.223.271-8pclos2018
- add Patches from arch

* Mon May 22 2017 bb2 <bb2> - 6.30.223.271-6pclos2017
- use arch build and Patches

* Fri May 19 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-5pclos2017
- rebuild 

* Sun Jan 22 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-4pclos2017
- dkms as noarch

* Sun Jan 22 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-3pclos2017
- new version build
- test on 4.9.5

* Sat Aug 27 2016 bb <bb> 6.30.223.271-2pclos2016
- fix build for kernel 4.7

* Tue May 31 2016 bb <bb> 6.30.223.271-1pclos2016
- update

* Mon Feb 01 2016 bb <bb> 6.30.233.248-4pclos2016
- Patch for kernel 4.1.x and 4.4.x fix

* Wed Sep 30 2015 bb <bb> 6.30.233.248-3pclos2015
- update for kernel 4.2.x

* Thu Apr 30 2015 bb <bb> 6.30.223.248-2pclos2015
- update for kernel 4.0.x

* Wed Dec 17 2014 bb <bb> 6.30.223.248-1pclos2014
- update for kernel 3.18
